### Type parameters

- #### T

### Hierarchy

- Array<T | NestedArray<T>>
  - NestedArray

### Indexable

[n: number]: T | NestedArray<T>

## Index

### Properties

- Array
- length

### Methods

- [Symbol.iterator]
- [Symbol.unscopables]
- concat
- copyWithin
- entries
- every
- fill
- filter
- find
- findIndex
- flat
- flatMap
- forEach
- includes
- indexOf
- join
- keys
- lastIndexOf
- map
- pop
- push
- reduce
- reduceRight
- reverse
- shift
- slice
- some
- sort
- splice
- toLocaleString
- toString
- unshift
- values

## Properties

### Array

Array: ArrayConstructor

- Defined in node_modules/typescript/lib/lib.es5.d.ts:1385

### length

length: number

Inherited from NestedArray.length

- Defined in node_modules/typescript/lib/lib.es5.d.ts:1215

Gets or sets the length of the array. This is a number one higher than the highest element defined in an array.

## Methods

### [Symbol.iterator]

- [Symbol.iterator](): IterableIterator<T | NestedArray<T>>

- Inherited from NestedArray.[Symbol.iterator]

  - Defined in node_modules/typescript/lib/lib.es2015.iterable.d.ts:60

  Iterator

  #### Returns IterableIterator<T | NestedArray<T>>

### [Symbol.unscopables]

- [Symbol.unscopables](): { copyWithin: boolean; entries: boolean; fill: boolean; find: boolean; findIndex: boolean; keys: boolean; values: boolean }

- Inherited from NestedArray.[Symbol.unscopables]

  - Defined in node_modules/typescript/lib/lib.es2015.symbol.wellknown.d.ts:94

  Returns an object whose properties have the value 'true' when they will be absent when used in a 'with' statement.

  #### Returns { copyWithin: boolean; entries: boolean; fill: boolean; find: boolean; findIndex: boolean; keys: boolean; values: boolean }

  - ##### copyWithin: boolean

  - ##### entries: boolean

  - ##### fill: boolean

  - ##### find: boolean

  - ##### findIndex: boolean

  - ##### keys: boolean

  - ##### values: boolean

### concat

- concat(...items: ConcatArray<T | NestedArray<T>>[]): (T | NestedArray<T>)[]
- concat(...items: (T | ConcatArray<T>)[]): (T | NestedArray<T>)[]

- Inherited from NestedArray.concat

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1237

  Combines two or more arrays.

  #### Parameters

  - ##### Rest ...items: ConcatArray<T | NestedArray<T>>[]

    Additional items to add to the end of array1.

  #### Returns (T | NestedArray<T>)[]

- Inherited from NestedArray.concat

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1242

  Combines two or more arrays.

  #### Parameters

  - ##### Rest ...items: (T | ConcatArray<T>)[]

    Additional items to add to the end of array1.

  #### Returns (T | NestedArray<T>)[]

### copyWithin

- copyWithin(target: number, start: number, end?: undefined | number): this

- Inherited from NestedArray.copyWithin

  - Defined in node_modules/typescript/lib/lib.es2015.core.d.ts:64

  Returns the this object after copying a section of the array identified by start and end to the same array starting at position target

  #### Parameters

  - ##### target: number

    If target is negative, it is treated as length+target where length is the length of the array.

  - ##### start: number

    If start is negative, it is treated as length+start. If end is negative, it is treated as length+end.

  - ##### Optional end: undefined | number

    If not specified, length of the this object is used as its default value.

  #### Returns this

### entries

- entries(): IterableIterator<[number, T | NestedArray<T>]>

- Inherited from NestedArray.entries

  - Defined in node_modules/typescript/lib/lib.es2015.iterable.d.ts:65

  Returns an iterable of key, value pairs for every entry in the array

  #### Returns IterableIterator<[number, T | NestedArray<T>]>

### every

- every(callbackfn: (value: T | NestedArray<T>, index: number, array: (T | NestedArray<T>)[]) => unknown, thisArg?: any): boolean

- Inherited from NestedArray.every

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1310

  Determines whether all the members of an array satisfy the specified test.

  #### Parameters

  - ##### callbackfn: (value: T | NestedArray<T>, index: number, array: (T | NestedArray<T>)[]) => unknown

    A function that accepts up to three arguments. The every method calls the callbackfn function for each element in the array until the callbackfn returns a value which is coercible to the Boolean value false, or until the end of the array.

    - - (value: T | NestedArray<T>, index: number, array: (T | NestedArray<T>)[]): unknown

      - #### Parameters

        - ##### value: T | NestedArray<T>

        - ##### index: number

        - ##### array: (T | NestedArray<T>)[]

        #### Returns unknown

  - ##### Optional thisArg: any

    An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.

  #### Returns boolean

### fill

- fill(value: T | NestedArray<T>, start?: undefined | number, end?: undefined | number): this

- Inherited from NestedArray.fill

  - Defined in node_modules/typescript/lib/lib.es2015.core.d.ts:53

  Returns the this object after filling the section identified by start and end with value

  #### Parameters

  - ##### value: T | NestedArray<T>

    value to fill array section with

  - ##### Optional start: undefined | number

    index to start filling the array at. If start is negative, it is treated as length+start where length is the length of the array.

  - ##### Optional end: undefined | number

    index to stop filling the array at. If end is negative, it is treated as length+end.

  #### Returns this

### filter

- filter<S>(callbackfn: (value: T | NestedArray<T>, index: number, array: (T | NestedArray<T>)[]) => value is S, thisArg?: any): S[]
- filter(callbackfn: (value: T | NestedArray<T>, index: number, array: (T | NestedArray<T>)[]) => unknown, thisArg?: any): (T | NestedArray<T>)[]

- Inherited from NestedArray.filter

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1337

  Returns the elements of an array that meet the condition specified in a callback function.

  #### Type parameters

  - #### S: T | NestedArray<T>

  #### Parameters

  - ##### callbackfn: (value: T | NestedArray<T>, index: number, array: (T | NestedArray<T>)[]) => value is S

    A function that accepts up to three arguments. The filter method calls the callbackfn function one time for each element in the array.

    - - (value: T | NestedArray<T>, index: number, array: (T | NestedArray<T>)[]): value is S

      - #### Parameters

        - ##### value: T | NestedArray<T>

        - ##### index: number

        - ##### array: (T | NestedArray<T>)[]

        #### Returns value is S

  - ##### Optional thisArg: any

    An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.

  #### Returns S[]

- Inherited from NestedArray.filter

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1343

  Returns the elements of an array that meet the condition specified in a callback function.

  #### Parameters

  - ##### callbackfn: (value: T | NestedArray<T>, index: number, array: (T | NestedArray<T>)[]) => unknown

    A function that accepts up to three arguments. The filter method calls the callbackfn function one time for each element in the array.

    - - (value: T | NestedArray<T>, index: number, array: (T | NestedArray<T>)[]): unknown

      - #### Parameters

        - ##### value: T | NestedArray<T>

        - ##### index: number

        - ##### array: (T | NestedArray<T>)[]

        #### Returns unknown

  - ##### Optional thisArg: any

    An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.

  #### Returns (T | NestedArray<T>)[]

### find

- find<S>(predicate: (this: void, value: T | NestedArray<T>, index: number, obj: (T | NestedArray<T>)[]) => value is S, thisArg?: any): S | undefined
- find(predicate: (value: T | NestedArray<T>, index: number, obj: (T | NestedArray<T>)[]) => unknown, thisArg?: any): (T | NestedArray<T>) | undefined

- Inherited from NestedArray.find

  - Defined in node_modules/typescript/lib/lib.es2015.core.d.ts:31

  Returns the value of the first element in the array where predicate is true, and undefined otherwise.

  #### Type parameters

  - #### S: T | NestedArray<T>

  #### Parameters

  - ##### predicate: (this: void, value: T | NestedArray<T>, index: number, obj: (T | NestedArray<T>)[]) => value is S

    find calls predicate once for each element of the array, in ascending order, until it finds one where predicate returns true. If such an element is found, find immediately returns that element value. Otherwise, find returns undefined.

    - - (this: void, value: T | NestedArray<T>, index: number, obj: (T | NestedArray<T>)[]): value is S

      - #### Parameters

        - ##### this: void

        - ##### value: T | NestedArray<T>

        - ##### index: number

        - ##### obj: (T | NestedArray<T>)[]

        #### Returns value is S

  - ##### Optional thisArg: any

    If provided, it will be used as the this value for each invocation of predicate. If it is not provided, undefined is used instead.

  #### Returns S | undefined

- Inherited from NestedArray.find

  - Defined in node_modules/typescript/lib/lib.es2015.core.d.ts:32

  #### Parameters

  - ##### predicate: (value: T | NestedArray<T>, index: number, obj: (T | NestedArray<T>)[]) => unknown

    - - (value: T | NestedArray<T>, index: number, obj: (T | NestedArray<T>)[]): unknown

      - #### Parameters

        - ##### value: T | NestedArray<T>

        - ##### index: number

        - ##### obj: (T | NestedArray<T>)[]

        #### Returns unknown

  - ##### Optional thisArg: any

  #### Returns (T | NestedArray<T>) | undefined

### findIndex

- findIndex(predicate: (value: T | NestedArray<T>, index: number, obj: (T | NestedArray<T>)[]) => unknown, thisArg?: any): number

- Inherited from NestedArray.findIndex

  - Defined in node_modules/typescript/lib/lib.es2015.core.d.ts:43

  Returns the index of the first element in the array where predicate is true, and -1 otherwise.

  #### Parameters

  - ##### predicate: (value: T | NestedArray<T>, index: number, obj: (T | NestedArray<T>)[]) => unknown

    find calls predicate once for each element of the array, in ascending order, until it finds one where predicate returns true. If such an element is found, findIndex immediately returns that element index. Otherwise, findIndex returns -1.

    - - (value: T | NestedArray<T>, index: number, obj: (T | NestedArray<T>)[]): unknown

      - #### Parameters

        - ##### value: T | NestedArray<T>

        - ##### index: number

        - ##### obj: (T | NestedArray<T>)[]

        #### Returns unknown

  - ##### Optional thisArg: any

    If provided, it will be used as the this value for each invocation of predicate. If it is not provided, undefined is used instead.

  #### Returns number

### flat

- flat<U>(this: U[][][][][][][][], depth: 7): U[]
- flat<U>(this: U[][][][][][][], depth: 6): U[]
- flat<U>(this: U[][][][][][], depth: 5): U[]
- flat<U>(this: U[][][][][], depth: 4): U[]
- flat<U>(this: U[][][][], depth: 3): U[]
- flat<U>(this: U[][][], depth: 2): U[]
- flat<U>(this: U[][], depth?: undefined | 1): U[]
- flat<U>(this: U[], depth: 0): U[]
- flat<U>(depth?: undefined | number): any[]

- Inherited from NestedArray.flat

  - Defined in node_modules/typescript/lib/lib.es2019.array.d.ts:158

  Returns a new array with all sub-array elements concatenated into it recursively up to the specified depth.

  #### Type parameters

  - #### U

  #### Parameters

  - ##### this: U[][][][][][][][]

  - ##### depth: 7

    The maximum recursion depth

  #### Returns U[]

- Inherited from NestedArray.flat

  - Defined in node_modules/typescript/lib/lib.es2019.array.d.ts:166

  Returns a new array with all sub-array elements concatenated into it recursively up to the specified depth.

  #### Type parameters

  - #### U

  #### Parameters

  - ##### this: U[][][][][][][]

  - ##### depth: 6

    The maximum recursion depth

  #### Returns U[]

- Inherited from NestedArray.flat

  - Defined in node_modules/typescript/lib/lib.es2019.array.d.ts:174

  Returns a new array with all sub-array elements concatenated into it recursively up to the specified depth.

  #### Type parameters

  - #### U

  #### Parameters

  - ##### this: U[][][][][][]

  - ##### depth: 5

    The maximum recursion depth

  #### Returns U[]

- Inherited from NestedArray.flat

  - Defined in node_modules/typescript/lib/lib.es2019.array.d.ts:182

  Returns a new array with all sub-array elements concatenated into it recursively up to the specified depth.

  #### Type parameters

  - #### U

  #### Parameters

  - ##### this: U[][][][][]

  - ##### depth: 4

    The maximum recursion depth

  #### Returns U[]

- Inherited from NestedArray.flat

  - Defined in node_modules/typescript/lib/lib.es2019.array.d.ts:190

  Returns a new array with all sub-array elements concatenated into it recursively up to the specified depth.

  #### Type parameters

  - #### U

  #### Parameters

  - ##### this: U[][][][]

  - ##### depth: 3

    The maximum recursion depth

  #### Returns U[]

- Inherited from NestedArray.flat

  - Defined in node_modules/typescript/lib/lib.es2019.array.d.ts:198

  Returns a new array with all sub-array elements concatenated into it recursively up to the specified depth.

  #### Type parameters

  - #### U

  #### Parameters

  - ##### this: U[][][]

  - ##### depth: 2

    The maximum recursion depth

  #### Returns U[]

- Inherited from NestedArray.flat

  - Defined in node_modules/typescript/lib/lib.es2019.array.d.ts:206

  Returns a new array with all sub-array elements concatenated into it recursively up to the specified depth.

  #### Type parameters

  - #### U

  #### Parameters

  - ##### this: U[][]

  - ##### Optional depth: undefined | 1

    The maximum recursion depth

  #### Returns U[]

- Inherited from NestedArray.flat

  - Defined in node_modules/typescript/lib/lib.es2019.array.d.ts:214

  Returns a new array with all sub-array elements concatenated into it recursively up to the specified depth.

  #### Type parameters

  - #### U

  #### Parameters

  - ##### this: U[]

  - ##### depth: 0

    The maximum recursion depth

  #### Returns U[]

- Inherited from NestedArray.flat

  - Defined in node_modules/typescript/lib/lib.es2019.array.d.ts:222

  Returns a new array with all sub-array elements concatenated into it recursively up to the specified depth. If no depth is provided, flat method defaults to the depth of 1.

  #### Type parameters

  - #### U

  #### Parameters

  - ##### Optional depth: undefined | number

    The maximum recursion depth

  #### Returns any[]

### flatMap

- flatMap<U, This>(callback: (this: This, value: T | NestedArray<T>, index: number, array: (T | NestedArray<T>)[]) => U | ReadonlyArray<U>, thisArg?: This): U[]

- Inherited from NestedArray.flatMap

  - Defined in node_modules/typescript/lib/lib.es2019.array.d.ts:147

  Calls a defined callback function on each element of an array. Then, flattens the result into a new array. This is identical to a map followed by flat with depth 1.

  #### Type parameters

  - #### U

  - #### This

  #### Parameters

  - ##### callback: (this: This, value: T | NestedArray<T>, index: number, array: (T | NestedArray<T>)[]) => U | ReadonlyArray<U>

    A function that accepts up to three arguments. The flatMap method calls the callback function one time for each element in the array.

    - - (this: This, value: T | NestedArray<T>, index: number, array: (T | NestedArray<T>)[]): U | ReadonlyArray<U>

      - #### Parameters

        - ##### this: This

        - ##### value: T | NestedArray<T>

        - ##### index: number

        - ##### array: (T | NestedArray<T>)[]

        #### Returns U | ReadonlyArray<U>

  - ##### Optional thisArg: This

    An object to which the this keyword can refer in the callback function. If thisArg is omitted, undefined is used as the this value.

  #### Returns U[]

### forEach

- forEach(callbackfn: (value: T | NestedArray<T>, index: number, array: (T | NestedArray<T>)[]) => void, thisArg?: any): void

- Inherited from NestedArray.forEach

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1325

  Performs the specified action for each element in an array.

  #### Parameters

  - ##### callbackfn: (value: T | NestedArray<T>, index: number, array: (T | NestedArray<T>)[]) => void

    A function that accepts up to three arguments. forEach calls the callbackfn function one time for each element in the array.

    - - (value: T | NestedArray<T>, index: number, array: (T | NestedArray<T>)[]): void

      - #### Parameters

        - ##### value: T | NestedArray<T>

        - ##### index: number

        - ##### array: (T | NestedArray<T>)[]

        #### Returns void

  - ##### Optional thisArg: any

    An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.

  #### Returns void

### includes

- includes(searchElement: T | NestedArray<T>, fromIndex?: undefined | number): boolean

- Inherited from NestedArray.includes

  - Defined in node_modules/typescript/lib/lib.es2016.array.include.d.ts:27

  Determines whether an array includes a certain element, returning true or false as appropriate.

  #### Parameters

  - ##### searchElement: T | NestedArray<T>

    The element to search for.

  - ##### Optional fromIndex: undefined | number

    The position in this array at which to begin searching for searchElement.

  #### Returns boolean

### indexOf

- indexOf(searchElement: T | NestedArray<T>, fromIndex?: undefined | number): number

- Inherited from NestedArray.indexOf

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1295

  Returns the index of the first occurrence of a value in an array.

  #### Parameters

  - ##### searchElement: T | NestedArray<T>

    The value to locate in the array.

  - ##### Optional fromIndex: undefined | number

    The array index at which to begin the search. If fromIndex is omitted, the search starts at index 0.

  #### Returns number

### join

- join(separator?: undefined | string): string

- Inherited from NestedArray.join

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1247

  Adds all the elements of an array separated by the specified separator string.

  #### Parameters

  - ##### Optional separator: undefined | string

    A string used to separate one element of an array from the next in the resulting String. If omitted, the array elements are separated with a comma.

  #### Returns string

### keys

- keys(): IterableIterator<number>

- Inherited from NestedArray.keys

  - Defined in node_modules/typescript/lib/lib.es2015.iterable.d.ts:70

  Returns an iterable of keys in the array

  #### Returns IterableIterator<number>

### lastIndexOf

- lastIndexOf(searchElement: T | NestedArray<T>, fromIndex?: undefined | number): number

- Inherited from NestedArray.lastIndexOf

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1301

  Returns the index of the last occurrence of a specified value in an array.

  #### Parameters

  - ##### searchElement: T | NestedArray<T>

    The value to locate in the array.

  - ##### Optional fromIndex: undefined | number

    The array index at which to begin the search. If fromIndex is omitted, the search starts at the last index in the array.

  #### Returns number

### map

- map<U>(callbackfn: (value: T | NestedArray<T>, index: number, array: (T | NestedArray<T>)[]) => U, thisArg?: any): U[]

- Inherited from NestedArray.map

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1331

  Calls a defined callback function on each element of an array, and returns an array that contains the results.

  #### Type parameters

  - #### U

  #### Parameters

  - ##### callbackfn: (value: T | NestedArray<T>, index: number, array: (T | NestedArray<T>)[]) => U

    A function that accepts up to three arguments. The map method calls the callbackfn function one time for each element in the array.

    - - (value: T | NestedArray<T>, index: number, array: (T | NestedArray<T>)[]): U

      - #### Parameters

        - ##### value: T | NestedArray<T>

        - ##### index: number

        - ##### array: (T | NestedArray<T>)[]

        #### Returns U

  - ##### Optional thisArg: any

    An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.

  #### Returns U[]

### pop

- pop(): (T | NestedArray<T>) | undefined

- Inherited from NestedArray.pop

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1227

  Removes the last element from an array and returns it.

  #### Returns (T | NestedArray<T>) | undefined

### push

- push(...items: (T | NestedArray<T>)[]): number

- Inherited from NestedArray.push

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1232

  Appends new elements to an array, and returns the new length of the array.

  #### Parameters

  - ##### Rest ...items: (T | NestedArray<T>)[]

    New elements of the Array.

  #### Returns number

### reduce

- reduce(callbackfn: (previousValue: T | NestedArray<T>, currentValue: T | NestedArray<T>, currentIndex: number, array: (T | NestedArray<T>)[]) => T | NestedArray<T>): T | NestedArray<T>
- reduce(callbackfn: (previousValue: T | NestedArray<T>, currentValue: T | NestedArray<T>, currentIndex: number, array: (T | NestedArray<T>)[]) => T | NestedArray<T>, initialValue: T | NestedArray<T>): T | NestedArray<T>
- reduce<U>(callbackfn: (previousValue: U, currentValue: T | NestedArray<T>, currentIndex: number, array: (T | NestedArray<T>)[]) => U, initialValue: U): U

- Inherited from NestedArray.reduce

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1349

  Calls the specified callback function for all the elements in an array. The return value of the callback function is the accumulated result, and is provided as an argument in the next call to the callback function.

  #### Parameters

  - ##### callbackfn: (previousValue: T | NestedArray<T>, currentValue: T | NestedArray<T>, currentIndex: number, array: (T | NestedArray<T>)[]) => T | NestedArray<T>

    A function that accepts up to four arguments. The reduce method calls the callbackfn function one time for each element in the array.

    - - (previousValue: T | NestedArray<T>, currentValue: T | NestedArray<T>, currentIndex: number, array: (T | NestedArray<T>)[]): T | NestedArray<T>

      - #### Parameters

        - ##### previousValue: T | NestedArray<T>

        - ##### currentValue: T | NestedArray<T>

        - ##### currentIndex: number

        - ##### array: (T | NestedArray<T>)[]

        #### Returns T | NestedArray<T>

- Inherited from NestedArray.reduce

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1350

  #### Parameters

  - ##### callbackfn: (previousValue: T | NestedArray<T>, currentValue: T | NestedArray<T>, currentIndex: number, array: (T | NestedArray<T>)[]) => T | NestedArray<T>

    - - (previousValue: T | NestedArray<T>, currentValue: T | NestedArray<T>, currentIndex: number, array: (T | NestedArray<T>)[]): T | NestedArray<T>

      - #### Parameters

        - ##### previousValue: T | NestedArray<T>

        - ##### currentValue: T | NestedArray<T>

        - ##### currentIndex: number

        - ##### array: (T | NestedArray<T>)[]

        #### Returns T | NestedArray<T>

  - ##### initialValue: T | NestedArray<T>

  #### Returns T | NestedArray<T>

- Inherited from NestedArray.reduce

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1356

  Calls the specified callback function for all the elements in an array. The return value of the callback function is the accumulated result, and is provided as an argument in the next call to the callback function.

  #### Type parameters

  - #### U

  #### Parameters

  - ##### callbackfn: (previousValue: U, currentValue: T | NestedArray<T>, currentIndex: number, array: (T | NestedArray<T>)[]) => U

    A function that accepts up to four arguments. The reduce method calls the callbackfn function one time for each element in the array.

    - - (previousValue: U, currentValue: T | NestedArray<T>, currentIndex: number, array: (T | NestedArray<T>)[]): U

      - #### Parameters

        - ##### previousValue: U

        - ##### currentValue: T | NestedArray<T>

        - ##### currentIndex: number

        - ##### array: (T | NestedArray<T>)[]

        #### Returns U

  - ##### initialValue: U

    If initialValue is specified, it is used as the initial value to start the accumulation. The first call to the callbackfn function provides this value as an argument instead of an array value.

  #### Returns U

### reduceRight

- reduceRight(callbackfn: (previousValue: T | NestedArray<T>, currentValue: T | NestedArray<T>, currentIndex: number, array: (T | NestedArray<T>)[]) => T | NestedArray<T>): T | NestedArray<T>
- reduceRight(callbackfn: (previousValue: T | NestedArray<T>, currentValue: T | NestedArray<T>, currentIndex: number, array: (T | NestedArray<T>)[]) => T | NestedArray<T>, initialValue: T | NestedArray<T>): T | NestedArray<T>
- reduceRight<U>(callbackfn: (previousValue: U, currentValue: T | NestedArray<T>, currentIndex: number, array: (T | NestedArray<T>)[]) => U, initialValue: U): U

- Inherited from NestedArray.reduceRight

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1362

  Calls the specified callback function for all the elements in an array, in descending order. The return value of the callback function is the accumulated result, and is provided as an argument in the next call to the callback function.

  #### Parameters

  - ##### callbackfn: (previousValue: T | NestedArray<T>, currentValue: T | NestedArray<T>, currentIndex: number, array: (T | NestedArray<T>)[]) => T | NestedArray<T>

    A function that accepts up to four arguments. The reduceRight method calls the callbackfn function one time for each element in the array.

    - - (previousValue: T | NestedArray<T>, currentValue: T | NestedArray<T>, currentIndex: number, array: (T | NestedArray<T>)[]): T | NestedArray<T>

      - #### Parameters

        - ##### previousValue: T | NestedArray<T>

        - ##### currentValue: T | NestedArray<T>

        - ##### currentIndex: number

        - ##### array: (T | NestedArray<T>)[]

        #### Returns T | NestedArray<T>

- Inherited from NestedArray.reduceRight

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1363

  #### Parameters

  - ##### callbackfn: (previousValue: T | NestedArray<T>, currentValue: T | NestedArray<T>, currentIndex: number, array: (T | NestedArray<T>)[]) => T | NestedArray<T>

    - - (previousValue: T | NestedArray<T>, currentValue: T | NestedArray<T>, currentIndex: number, array: (T | NestedArray<T>)[]): T | NestedArray<T>

      - #### Parameters

        - ##### previousValue: T | NestedArray<T>

        - ##### currentValue: T | NestedArray<T>

        - ##### currentIndex: number

        - ##### array: (T | NestedArray<T>)[]

        #### Returns T | NestedArray<T>

  - ##### initialValue: T | NestedArray<T>

  #### Returns T | NestedArray<T>

- Inherited from NestedArray.reduceRight

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1369

  Calls the specified callback function for all the elements in an array, in descending order. The return value of the callback function is the accumulated result, and is provided as an argument in the next call to the callback function.

  #### Type parameters

  - #### U

  #### Parameters

  - ##### callbackfn: (previousValue: U, currentValue: T | NestedArray<T>, currentIndex: number, array: (T | NestedArray<T>)[]) => U

    A function that accepts up to four arguments. The reduceRight method calls the callbackfn function one time for each element in the array.

    - - (previousValue: U, currentValue: T | NestedArray<T>, currentIndex: number, array: (T | NestedArray<T>)[]): U

      - #### Parameters

        - ##### previousValue: U

        - ##### currentValue: T | NestedArray<T>

        - ##### currentIndex: number

        - ##### array: (T | NestedArray<T>)[]

        #### Returns U

  - ##### initialValue: U

    If initialValue is specified, it is used as the initial value to start the accumulation. The first call to the callbackfn function provides this value as an argument instead of an array value.

  #### Returns U

### reverse

- reverse(): (T | NestedArray<T>)[]

- Inherited from NestedArray.reverse

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1251

  Reverses the elements in an Array.

  #### Returns (T | NestedArray<T>)[]

### shift

- shift(): (T | NestedArray<T>) | undefined

- Inherited from NestedArray.shift

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1255

  Removes the first element from an array and returns it.

  #### Returns (T | NestedArray<T>) | undefined

### slice

- slice(start?: undefined | number, end?: undefined | number): (T | NestedArray<T>)[]

- Inherited from NestedArray.slice

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1261

  Returns a section of an array.

  #### Parameters

  - ##### Optional start: undefined | number

    The beginning of the specified portion of the array.

  - ##### Optional end: undefined | number

    The end of the specified portion of the array. This is exclusive of the element at the index 'end'.

  #### Returns (T | NestedArray<T>)[]

### some

- some(callbackfn: (value: T | NestedArray<T>, index: number, array: (T | NestedArray<T>)[]) => unknown, thisArg?: any): boolean

- Inherited from NestedArray.some

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1319

  Determines whether the specified callback function returns true for any element of an array.

  #### Parameters

  - ##### callbackfn: (value: T | NestedArray<T>, index: number, array: (T | NestedArray<T>)[]) => unknown

    A function that accepts up to three arguments. The some method calls the callbackfn function for each element in the array until the callbackfn returns a value which is coercible to the Boolean value true, or until the end of the array.

    - - (value: T | NestedArray<T>, index: number, array: (T | NestedArray<T>)[]): unknown

      - #### Parameters

        - ##### value: T | NestedArray<T>

        - ##### index: number

        - ##### array: (T | NestedArray<T>)[]

        #### Returns unknown

  - ##### Optional thisArg: any

    An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.

  #### Returns boolean

### sort

- sort(compareFn?: undefined | ((a: T | NestedArray<T>, b: T | NestedArray<T>) => number)): this

- Inherited from NestedArray.sort

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1271

  Sorts an array.

  #### Parameters

  - ##### Optional compareFn: undefined | ((a: T | NestedArray<T>, b: T | NestedArray<T>) => number)

    Function used to determine the order of the elements. It is expected to return a negative value if first argument is less than second argument, zero if they're equal and a positive value otherwise. If omitted, the elements are sorted in ascending, ASCII character order.

        [11,2,22,1].sort((a, b) => a - b)

  #### Returns this

### splice

- splice(start: number, deleteCount?: undefined | number): (T | NestedArray<T>)[]
- splice(start: number, deleteCount: number, ...items: (T | NestedArray<T>)[]): (T | NestedArray<T>)[]

- Inherited from NestedArray.splice

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1277

  Removes elements from an array and, if necessary, inserts new elements in their place, returning the deleted elements.

  #### Parameters

  - ##### start: number

    The zero-based location in the array from which to start removing elements.

  - ##### Optional deleteCount: undefined | number

    The number of elements to remove.

  #### Returns (T | NestedArray<T>)[]

- Inherited from NestedArray.splice

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1284

  Removes elements from an array and, if necessary, inserts new elements in their place, returning the deleted elements.

  #### Parameters

  - ##### start: number

    The zero-based location in the array from which to start removing elements.

  - ##### deleteCount: number

    The number of elements to remove.

  - ##### Rest ...items: (T | NestedArray<T>)[]

    Elements to insert into the array in place of the deleted elements.

  #### Returns (T | NestedArray<T>)[]

### toLocaleString

- toLocaleString(): string

- Inherited from NestedArray.toLocaleString

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1223

  Returns a string representation of an array. The elements are converted to string using their toLocalString methods.

  #### Returns string

### toString

- toString(): string

- Inherited from NestedArray.toString

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1219

  Returns a string representation of an array.

  #### Returns string

### unshift

- unshift(...items: (T | NestedArray<T>)[]): number

- Inherited from NestedArray.unshift

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1289

  Inserts new elements at the start of an array.

  #### Parameters

  - ##### Rest ...items: (T | NestedArray<T>)[]

    Elements to insert at the start of the Array.

  #### Returns number

### values

- values(): IterableIterator<T | NestedArray<T>>

- Inherited from NestedArray.values

  - Defined in node_modules/typescript/lib/lib.es2015.iterable.d.ts:75

  Returns an iterable of values in the array

  #### Returns IterableIterator<T | NestedArray<T>>